SystemOrganization addCategory: #'PackageInfo-Exporters'!

!Class methodsFor: '*packageinfo-exporters' stamp: 'avi 4/27/2004 14:11'!
visualworksName
	^ self name! !

!TestCase class methodsFor: '*packageinfo-exporters' stamp: 'avi 4/27/2004 14:14'!
visualworksName
	^ self == TestCase ifTrue: ['XProgramming.SUnit.TestCase'] ifFalse: [self name]! !

!Object class methodsFor: '*packageinfo-exporters' stamp: 'mb 12/20/2004 14:40'!
visualworksName
	(self name copyFrom: 1 to: 2) = 'WA' ifTrue: [^'Seaside.', self name].
	^ self == Object ifTrue: ['Core.Object'] ifFalse: [self name]! !

Object subclass: #PackageExporter
	instanceVariableNames: 'package stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PackageInfo-Exporters'!

!PackageExporter methodsFor: 'as yet unclassified' stamp: 'ab 5/23/2003 22:46'!
package: aPackageInfo
	package _ aPackageInfo! !

!PackageExporter class methodsFor: 'as yet unclassified' stamp: 'avi 10/11/2003 14:35'!
extension
	^ nil! !

!PackageExporter class methodsFor: 'as yet unclassified' stamp: 'avi 10/11/2003 13:03'!
initialize
	PackageServices register: self! !

!PackageExporter class methodsFor: 'as yet unclassified' stamp: 'ab 5/23/2003 23:09'!
fileOutPackageNamed: packageName on: aStream
	self fileOutPackage: (PackageInfo named: packageName) on: aStream! !

PackageExporter subclass: #VAPackageExporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PackageInfo-Exporters'!

!VAPackageExporter methodsFor: 'as yet unclassified' stamp: 'bp 12/14/2003 23:24'!
fileOutInitializers
	stream cr.
	(ChangeSet superclassOrder: package classes)
		do: [:ea | stream
			cr;
			nextPutAll: ea name asString;
			nextPutAll: ' initializeAfterLoad!!']
		displayingProgress: 'Filing out initializers...'.
	stream
		cr;
		nextPutAll: self application;
		nextPutAll: ' initializeAfterLoad!!'! !

!VAPackageExporter methodsFor: 'as yet unclassified' stamp: 'bp 12/14/2003 20:35'!
fileOutApplication

	stream
		nextPutAll: 'Application create: #';
		nextPutAll: self application;
		nextPutAll: ' with:
    (#( Kernel)
        collect: [:each | Smalltalk at: each ifAbsent: [
            Application errorPrerequisite: #';
		nextPutAll: self application;
		nextPutAll: ' missing: each]])!!'
! !

!VAPackageExporter class methodsFor: 'as yet unclassified' stamp: 'bp 3/21/2004 00:32'!
extension

	^ '.app'! !

!VAPackageExporter methodsFor: 'as yet unclassified' stamp: 'bp 12/14/2003 22:20'!
fileOut

	self
		fileOutApplication;
		fileOutClassDefinitions;
		fileOutApplicationClass;
		fileOutMethods;
		fileOutInitializers;
		fileOutLoaded! !

!VAPackageExporter methodsFor: 'as yet unclassified' stamp: 'bp 12/14/2003 23:22'!
fileOutLoaded

	stream
		cr;
		cr;
		nextPutAll: self application;
		nextPutAll: ' loaded!!'! !

!VAPackageExporter methodsFor: 'as yet unclassified' stamp: 'bp 12/14/2003 23:25'!
fileOutMethods
	stream
		nextPutAll: self application;
		nextPutAll: ' becomeDefault!!'.
	(ChangeSet superclassOrder: package classes)
		do: [:ea |
			self
				fileOutMethods: (package coreMethodsForClass: ea class) forClass: ea class;
				fileOutMethods: (package coreMethodsForClass: ea) forClass: ea]
		displayingProgress: 'Filing out core methods...'.
	package externalClasses
		do: [:ea |
			self
				fileOutMethods: (package extensionMethodsForClass: ea)
				forClass: ea]
		displayingProgress: 'Filing out extension methods...'.! !

!VAPackageExporter methodsFor: 'as yet unclassified' stamp: 'bp 12/14/2003 20:36'!
fileOutClassDefinitions
	(ChangeSet superclassOrder: package classes)
		do: [:ea | self fileOutClassDefinition: ea]
		displayingProgress: 'Filing out classes...'! !

!VAPackageExporter methodsFor: 'as yet unclassified' stamp: 'bp 12/14/2003 22:31'!
application
	^ package externalName! !

!VAPackageExporter methodsFor: 'as yet unclassified' stamp: 'bp 12/20/2003 21:07'!
fileOutClassDefinition: aClass
	stream
		cr;
		cr;
		nextPutAll: self application;
		nextPutAll: ' becomeDefault!!';
		cr;
		nextPutAll: aClass superclass name asString;
		nextPutAll: ' subclass: #';
		nextPutAll: aClass name;
		nextPutAll: '
	classInstanceVariableNames: ''';
		nextPutAll: aClass class instanceVariablesString;
		nextPutAll: '''
	instanceVariableNames: ''';
		nextPutAll: aClass instanceVariablesString;
		nextPutAll: '''
	classVariableNames: ''';
		nextPutAll: aClass classVariablesString;
		nextPutAll: '''
	poolDictionaries: ''''!!';
		cr;
		cr.

	aClass hasComment ifTrue: [
		stream nextChunkPut: (aClass name , ' comment: ''' , aClass comment , '''')]
! !

!VAPackageExporter methodsFor: 'as yet unclassified' stamp: 'bp 12/14/2003 23:58'!
fileOutMethods: methods forClass: aClass
	methods isEmpty ifTrue: [^self].
	stream
		cr;
		cr;
		nextPutAll: '!!';
		nextPutAll: aClass name asString;
		nextPutAll: ' publicMethods !!'.
	methods do: [:each |
		stream
			cr;
			cr;
			nextChunkPut: (self prettyPrint: each sourceCode)].

	stream
		nextPutAll: ' !!';
		cr.
	methods do: [:each |
		stream
			cr;
			nextPutAll: aClass name asString;
			nextPutAll: ' categoriesFor: #''';
			nextPutAll: each methodSymbol asString;
			nextPutAll: ''' are: #(''';
			nextPutAll: (self category: each);
			nextPutAll: ''')!!']! !

!VAPackageExporter methodsFor: 'as yet unclassified' stamp: 'bp 12/14/2003 23:05'!
fileOutApplicationClass

	stream
		nextPutAll: self application;
		nextPutAll: ' becomeDefault!!
Application subclass: #';
		nextPutAll: self application;
		nextPutAll: '
    instanceVariableNames: ''''
    classVariableNames: ''''
    poolDictionaries: ''''!!';
		cr;
		cr! !

!VAPackageExporter methodsFor: 'as yet unclassified' stamp: 'bp 12/14/2003 23:55'!
category: aMethodReference

	| category |
	category _ aMethodReference category.
	(category = 'as yet unclassified' or: [
		category = package methodCategoryPrefix]) ifTrue: [
		^'Not categorized'].
	(package isYourClassExtension: category) ifTrue: [
		^category
			copyFrom: package methodCategoryPrefix size + 1
			to: category size].
	^category! !

!PackageExporter class methodsFor: 'as yet unclassified' stamp: 'avi 10/11/2003 13:26'!
unload
	PackageServices unregister: self! !

!PackageExporter class methodsFor: 'as yet unclassified' stamp: 'avi 10/11/2003 13:07'!
exportService
	^ SimpleServiceEntry 
		provider: self
		label: 'export package'
		selector: #exportPackage:
		description: 'export package'! !

PackageExporter subclass: #VW5PackageExporter
	instanceVariableNames: 'environment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PackageInfo-Exporters'!

!VW5PackageExporter methodsFor: 'as yet unclassified' stamp: 'ab 6/14/2003 17:40'!
fileOutMethodBody: aMethodReference
	stream
		nextPutAll: '<body package="';
		nextPutAll: (self packageNameForMethod: aMethodReference);
		nextPutAll: '">';
		nextPutAll: (self prettyPrint: aMethodReference sourceCode asString) escapeEntities;
		nextPutAll: '</body>';
		cr! !

!VW5PackageExporter methodsFor: 'as yet unclassified' stamp: 'ab 6/14/2003 17:46'!
environment
	^ package externalName! !

!VW5PackageExporter methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 16:54'!
fileOutMethods
	package methods
		do: [:ea | self fileOutMethod: ea]
		displayingProgress: 'Filing out methods...'! !

!VW5PackageExporter methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 11:12'!
packageNameForMethod: aMethodReference
	^ (package includesClass: aMethodReference actualClass)
		ifTrue: [self packageNameForClass: aMethodReference actualClass]
		ifFalse: [self environment, '-Extensions']! !

!VW5PackageExporter methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 16:59'!
tag: aString do: aBlock
	stream
		nextPutAll: '<';
		nextPutAll: aString;
		nextPutAll: '>';
		cr.
	aBlock value.
	stream
		nextPutAll: '</';
		nextPutAll: aString;
		nextPutAll: '>';
		cr.! !

!VW5PackageExporter class methodsFor: 'as yet unclassified' stamp: 'avi 10/11/2003 14:36'!
extension
	^ '-vw5.st'! !

!VW5PackageExporter methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 17:39'!
fileOutInitializerForClass: aClass
	self tag: 'initialize' do: [
		self tag: 'class-id' with: (self fullyQualifiedClassNameFor: aClass)
	]! !

!VW5PackageExporter methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 16:56'!
fileOutMethod: aMethodReference
	self tag: 'methods' do: [
		self tag: 'class-id' with: (self fullyQualifiedClassNameFor: aMethodReference actualClass).
		self tag: 'category' with: aMethodReference category.
		self fileOutMethodBody: aMethodReference.
	]! !

!VW5PackageExporter methodsFor: 'as yet unclassified' stamp: 'mb 12/20/2004 14:11'!
fileOutClassDefinition: aClass
	stream cr.
	
	self tag: 'class' do: [
		self tag: 'name' with: aClass name.
		self tag: 'environment' with: self environment.
		self tag: 'super' with: (self fullyQualifiedClassNameFor: aClass superclass).
		self tag: 'private' with: 'false'.
		self tag: 'indexed-type' with: (self mapType: aClass typeOfClass).
		self tag: 'inst-vars' with: aClass instanceVariablesString.
		self tag: 'class-inst-vars' with: aClass class instanceVariablesString.
		self tag: 'imports' with: ''.
		self tag: 'category' with: aClass category.
		self tag: 'attributes' do: [
			self tag: 'package' with: (self packageNameForClass: aClass).
		]
	].

	aClass classPool keys do: [:ea | self fileOutClassVariable: ea class: aClass].
	
	self fileOutClassCommentForClass: aClass! !

!VW5PackageExporter methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 17:21'!
mapType: aSymbol
	aSymbol == #normal ifTrue: [^ #none].
	aSymbol == #variable ifTrue: [^ #objects].
	^ aSymbol
! !

!VW5PackageExporter methodsFor: 'as yet unclassified' stamp: 'mb 12/20/2004 14:20'!
fileOutClassCommentForClass: aClass
	
	aClass hasComment ifFalse: [^self].
	stream cr.
	self tag: 'comment' do: [
		self tag: 'class-id' with: (self fullyQualifiedClassNameFor: aClass).
		self tag: 'body' with: aClass comment asString.
	]! !

!VW5PackageExporter methodsFor: 'as yet unclassified' stamp: 'ab 6/14/2003 17:44'!
packageNameForClass: aClass
	^ aClass theNonMetaClass category! !

!VW5PackageExporter methodsFor: 'as yet unclassified' stamp: 'mb 12/20/2004 14:54'!
nameSpaceImports

	| imports result |
	imports := Set new.
	package classes do:
		[:ea |
		(ea name copyFrom: 1 to: 2) = 'WA'
			ifTrue: [imports add: #Seaside].
		(ea superclass name copyFrom: 1 to: 2) = 'WA'
			ifTrue: [imports add: #Seaside]].
	result := String new writeStream.
	result nextPutAll: 'Smalltalk.*'.
	imports do: [:ea | result space; nextPutAll: ea; nextPutAll: '.*'].
	^ result contents
! !

!VW5PackageExporter methodsFor: 'as yet unclassified' stamp: 'avi 4/27/2004 14:11'!
fullyQualifiedClassNameFor: aClass
	^ (package includesClass: aClass)
		ifTrue: [self environment, '.', aClass name]
		ifFalse: [aClass visualworksName]! !

!VW5PackageExporter methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 18:03'!
fileOutClassVariable: aSymbol class: aClass
	stream cr; cr.
	
	self tag: 'shared-variable' do: [
		self tag: 'name' with: aSymbol.
		self tag: 'environment' with: (self fullyQualifiedClassNameFor: aClass).
		self tag: 'private' with: 'false'.
		self tag: 'constant' with: 'false'.
		self tag: 'category' with: 'class variables'.
		self tag: 'initializer' with: 'nil'.
		self tag: 'attributes' do: [
			self tag: 'package' with: (self packageNameForClass: aClass).
		]
	]! !

!VW5PackageExporter methodsFor: 'as yet unclassified' stamp: 'avi 4/27/2004 14:14'!
fileOut
	stream nextPutAll: '<?xml version="1.0"?>'; cr; cr.
	
	self tag: 'st-source' do: [
		self fileOutTimeStamp.
		self fileOutNameSpace.
		self fileOutClassDefinitions.
		self fileOutMethods.
		self fileOutInitializers.
	].

	stream close.! !

!VW5PackageExporter methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 17:38'!
fileOutInitializers		
	(package classes select: [:c | c class includesSelector: #initialize])
		do: [:class | self fileOutInitializerForClass: class].! !

!VW5PackageExporter methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 16:59'!
tag: aString with: contentString
	stream
		nextPutAll: '<';
		nextPutAll: aString;
		nextPutAll: '>';
		nextPutAll: contentString;
		nextPutAll: '</';
		nextPutAll: aString;
		nextPutAll: '>';
		cr.! !

!VW5PackageExporter methodsFor: 'as yet unclassified' stamp: 'mb 12/20/2004 14:52'!
fileOutNameSpace
	self tag: 'name-space' do: [
		self tag: 'name' with: self environment.
		self tag: 'environment' with: 'Smalltalk'.
		self tag: 'private' with: 'false'.
		self tag: 'imports' do: [
			stream nextPutAll: self nameSpaceImports; cr.
		].
		self tag: 'category' with: self environment.
		self tag: 'attributes' do: [
			self tag: 'package' with: self environment.
		].
	]! !

!VW5PackageExporter methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 17:43'!
fileOutTimeStamp
	self tag: 'time-stamp' with:
		'From ', Smalltalk version, ' on ', Date today printString, ' at ', Time now printString! !

!VW5PackageExporter methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 17:22'!
fileOutClassDefinitions
	(ChangeSet superclassOrder: package classes)
		do: [:ea | self fileOutClassDefinition: ea]
		displayingProgress: 'Filing out classes...'
		! !

PackageExporter subclass: #ChangeSetPackageExporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PackageInfo-Exporters'!

!ChangeSetPackageExporter methodsFor: 'as yet unclassified' stamp: 'ab 5/23/2003 23:10'!
fileOutClassDefinitions
	(ChangeSet superclassOrder: package classesAndMetaClasses)
		do: [:class | self fileOutDefinitionForClass: class]
		displayingProgress: 'Filing out classes...'.! !

!ChangeSetPackageExporter methodsFor: 'as yet unclassified' stamp: 'ab 5/23/2003 22:55'!
fileOutInitializerForClass: aClass
	stream nextChunkPut: aClass name, ' initialize'; cr! !

!ChangeSetPackageExporter methodsFor: 'as yet unclassified' stamp: 'ab 5/23/2003 22:55'!
fileOutInitializers		
	(package classes select: [:c | c class includesSelector: #initialize])
		do: [:class | self fileOutInitializerForClass: class].! !

!ChangeSetPackageExporter methodsFor: 'as yet unclassified' stamp: 'ab 5/23/2003 22:56'!
fileOut
	self fileOutSystemCategories.
	self fileOutClassDefinitions.
	self fileOutClassComments.
	self fileOutMethods.
	self fileOutInitializers.
! !

ChangeSetPackageExporter subclass: #VW3PackageExporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PackageInfo-Exporters'!

!VW3PackageExporter methodsFor: 'as yet unclassified' stamp: 'ab 5/23/2003 23:11'!
fileOutMethod: aMethodReference
	stream
		cr;
		nextPutAll: '!!';
		nextPutAll: aMethodReference classSymbol;
		space.
	aMethodReference classIsMeta ifTrue: [stream nextPutAll: 'class '].
	stream
		nextPutAll: 'methodsFor: ';
		nextPutAll: aMethodReference category asString printString;
		nextPutAll: '!!';
		cr;
		nextChunkPut: (self prettyPrint: aMethodReference sourceCode);
		nextPutAll: ' !!';
		cr! !

!VW3PackageExporter methodsFor: 'as yet unclassified' stamp: 'ab 5/23/2003 22:57'!
fileOutClassComments
	"not yet implemented"! !

!VW3PackageExporter class methodsFor: 'as yet unclassified' stamp: 'avi 10/11/2003 14:36'!
extension
	^ '-vw3.st'! !

!VW3PackageExporter methodsFor: 'as yet unclassified' stamp: 'ab 5/23/2003 22:57'!
fileOutSystemCategories
	""! !

!ChangeSetPackageExporter methodsFor: 'as yet unclassified' stamp: 'ab 5/23/2003 22:54'!
fileOutMethods
	self sortedMethods
		do: [:ref | self fileOutMethod: ref]
		displayingProgress: 'Filing out methods...'.! !

!ChangeSetPackageExporter methodsFor: 'as yet unclassified' stamp: 'ab 5/23/2003 22:51'!
fileOutDefinitionForClass: aClass
	stream nextChunkPut: aClass definition; cr; cr! !

!ChangeSetPackageExporter methodsFor: 'as yet unclassified' stamp: 'ab 5/23/2003 22:54'!
sortedMethods
 ^ package methods sortBy:
		[:a :b |
		a methodSymbol < b methodSymbol
			or: [a methodSymbol = b methodSymbol
					and: [a classSymbol <= b classSymbol]]]! !

!ChangeSetPackageExporter methodsFor: 'as yet unclassified' stamp: 'ab 5/23/2003 22:52'!
fileOutClassComments
	package classes do:
		[:class |
		class organization classComment isEmpty
			ifFalse: [self fileOutCommentForClass: class ]].
		! !

!ChangeSetPackageExporter methodsFor: 'as yet unclassified' stamp: 'ab 5/23/2003 22:54'!
fileOutMethod: aMethodReference
	aMethodReference actualClass
		printMethodChunk: aMethodReference methodSymbol
		withPreamble: true
		on: stream
		moveSource: false
		toFile: 0! !

!ChangeSetPackageExporter methodsFor: 'as yet unclassified' stamp: 'ab 5/23/2003 22:52'!
fileOutCommentForClass: aClass
	aClass organization
		putCommentOnFile: stream
		numbered: 0
		moveSource: false
		forClass: aClass! !

!ChangeSetPackageExporter class methodsFor: 'as yet unclassified' stamp: 'avi 10/11/2003 14:36'!
extension
	^ '.st'! !

!ChangeSetPackageExporter methodsFor: 'as yet unclassified' stamp: 'ab 5/23/2003 22:50'!
fileOutSystemCategory: categoryName
	stream
		nextChunkPut: 'SystemOrganization addCategory: ', categoryName printString;
		cr! !

!ChangeSetPackageExporter methodsFor: 'as yet unclassified' stamp: 'ab 5/23/2003 22:56'!
fileOutSystemCategories
	package systemCategories do: [:cat | self fileOutSystemCategory: cat].
	stream cr; cr.

	! !

!PackageExporter class methodsFor: 'as yet unclassified' stamp: 'ab 5/23/2003 23:09'!
fileOutPackage: aPackageInfo on: aStream
	self new
		package: aPackageInfo;
		stream: aStream;
		fileOut! !

!PackageExporter methodsFor: 'as yet unclassified' stamp: 'ab 5/23/2003 22:47'!
fileOut
	self subclassResponsibility! !

!PackageExporter methodsFor: 'as yet unclassified' stamp: 'avi 4/27/2004 14:21'!
prettyPrint: aString
	|  previousChar |
	"Replace _ with := unless it is preceded with $ or a single quote"
	previousChar := nil.
	^ String streamContents:
		[:s |
		aString do:
			[:c |
			(c = $_ and: [ (#( $$ $' ) includes: previousChar) not])
				ifFalse: [s nextPut: c]
				ifTrue: [s nextPutAll: ':='].
			previousChar := c]]! !

!PackageExporter class methodsFor: 'as yet unclassified' stamp: 'avi 10/11/2003 14:38'!
exportPackage: aPackage
	| choice |
	subclasses _ self concreteSubclasses.
	choice _ (PopUpMenu labelArray: (subclasses collect: [:ea | aPackage packageName, ea extension])) startUp.
	choice = 0 ifFalse: [(subclasses at: choice) fileOutPackage: aPackage]! !

!PackageExporter class methodsFor: 'as yet unclassified' stamp: 'avi 10/11/2003 13:04'!
services
	^ Array with: self exportService! !

!PackageExporter class methodsFor: 'as yet unclassified' stamp: 'cwp 5/9/2004 12:22'!
concreteSubclasses
	^ (self allSubclasses select: [:ea | ea extension notNil]) asArray! !

!PackageExporter methodsFor: 'as yet unclassified' stamp: 'ab 5/23/2003 22:47'!
stream: aStream
	stream _ aStream! !

!PackageExporter class methodsFor: 'as yet unclassified' stamp: 'avi 10/11/2003 11:43'!
fileOutPackageNamed: aString
	self fileOutPackage: (PackageInfo named: aString)! !

!PackageExporter class methodsFor: 'as yet unclassified' stamp: 'avi 5/12/2004 13:37'!
fileOutPackage: aPackage
	| stream |
	stream _ FileStream forceNewFileNamed: aPackage externalName, self extension.
	self fileOutPackage: aPackage on: stream.
	stream close.! !

!Behavior methodsFor: '*packageinfo-exporters' stamp: 'mb 12/20/2004 14:44'!
visualworksName
	^ (self name copyFrom: 1 to: 2) = 'WA'
		ifTrue: ['Seaside.', self name]
		ifFalse: [self name]! !
PackageExporter initialize!
